/////////////////////////////////////////////////////////////////////////////
// NAME: globals.h
// FUNKTION: Headerdatei mit globalen Definitionen
// ERSTELLT: 02/2004 - Erwin Baeck
/////////////////////////////////////////////////////////////////////////////
#ifndef	___GLOBALS_H___
#define	___GLOBALS_H___

#define INT_ON				#asm("sei")	//enable global interrupts
#define INT_OFF				#asm("cli")	//disable global interrupts

#define RESET_WATCHDOG		#asm("wdr")	//reset watchdog

#define TRUE		1
#define FALSE		0
#define HIGH		1
#define LOW			0
#define ON			1
#define OFF			0
#define YES			1
#define NO			0

// ASCII-Steuerzeichen
#define NUL			0x00
#define SOH			0x01
#define STX			0x02
#define ETX			0x03
#define EOT			0x04
#define ENQ			0x05
#define ACK			0x06
#define BEL			0x07
#define BS			0x08
#define HT			0x09
#define LF 			0x0A
#define VT			0x0B
#define FF			0x0C
#define CR			0x0D
#define SO			0x0E
#define SI			0x0F
#define DLE			0x10
#define DC1			0x11
#define DC2			0x12
#define DC3			0x13
#define DC4			0x14
#define NAK			0x15
#define SYN			0x16
#define ETB			0x17
#define CAN			0x18
#define EM			0x19
#define SUB			0x1A
#define ESC			0x1B
#define FS			0x1C
#define GS			0x1D
#define RS			0x1E
#define US			0x1F

#define SPC			0x20

#define PCRLF printf("\n\r")

//---------------------------------------------------------------------------
// IO-Port Definitionen
//---------------------------------------------------------------------------
#define LED_ON		PORTB.2 = LOW
#define LED_OFF		PORTB.2 = HIGH

#define MOT1_ON		PORTD.7 = LOW
#define MOT1_OFF	PORTD.7 = HIGH
#define MOT2_ON		PORTB.3 = LOW
#define MOT2_OFF	PORTB.3 = HIGH

#define BEEP_ON		PORTB.7 = LOW
#define BEEP_OFF	PORTB.7 = HIGH

//---------------------------------------------------------------------------
// Typedefs
//---------------------------------------------------------------------------
typedef signed char      	BYTE;	//Zahl im Bereich -128 - +127
typedef unsigned char   	UBYTE;	//Zahl im Bereich 0 - 255
typedef signed int       	WORD;	//Zahl im Bereich -32768 - +32767
typedef unsigned int    	UWORD;	//Zahl im Bereich 0 - 65535
typedef signed long      	LONG;	//Zahl im Bereich -2147483648 - 2147483647
typedef unsigned long   	ULONG;	//Zahl im Bereich 0 - 4294967295

#endif //___GLOBALS_H___

/////////////////////////////////////////////////////////////////////////////
// Ende von globals.h
/////////////////////////////////////////////////////////////////////////////
