/*
  Prototypes for the Dallas Semiconductor
  DS1621 I2C bus thermometer/thermostat functions

  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <ds1621.h>
*/

#ifndef _DS1621_INCLUDED_
#define _DS1621_INCLUDED_

#include <i2c.h>

#pragma used+

void ds1621_init(unsigned char chip,signed char tlow,signed char thigh,
unsigned char pol);
unsigned char ds1621_get_status(unsigned char chip);
void ds1621_set_status(unsigned char chip,unsigned char status);
void ds1621_start(unsigned char chip);
void ds1621_stop(unsigned char chip);
int ds1621_temperature_10(unsigned char chip);

#pragma used-
#pragma library ds1621.lib

#endif

