/*
  National Semiconductor LM75 I2C bus
  temperature sensor functions

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <lm75.h>
*/

#ifndef _LM75_INCLUDED_
#define _LM75_INCLUDED_

#include <i2c.h>

#pragma used+

void lm75_init(unsigned char chip,signed char thyst,signed char tos,
unsigned char pol);
int lm75_temperature_10(unsigned char chip);

#pragma used-

#pragma library lm75.lib

#endif

