/*
  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for the Philips PCF8583 I2C
  bus Real Time Clock functions
*/

#ifndef _PCF8583_INCLUDED_
#define _PCF8583_INCLUDED_

#include <i2c_hw.h>

#pragma used+

unsigned char __rtc_status;
bit __rtc_alarm;

unsigned char rtc_read(unsigned char chip,unsigned char address);
void rtc_write(unsigned char chip, unsigned char address,unsigned char data);
unsigned char rtc_get_status(unsigned char chip);
void rtc_init(unsigned char chip,unsigned char dated_alarm);
void rtc_alarm_off(unsigned char chip);
void rtc_alarm_on(unsigned char chip);
void rtc_get_time(unsigned char chip,unsigned char *hour,unsigned char *min,
unsigned char *sec,unsigned char *hsec);
void rtc_set_time(unsigned char chip,unsigned char hour,unsigned char min,
unsigned char sec,unsigned char hsec);
void rtc_get_date(unsigned char chip,unsigned char *date,unsigned char *month,
unsigned *year);
void rtc_set_date(unsigned char chip,unsigned char date,unsigned char month,
unsigned year);
void rtc_get_alarm_time(unsigned char chip,unsigned char *hour,
unsigned char *min,unsigned char *sec,unsigned char *hsec);
void rtc_set_alarm_time(unsigned char chip,unsigned char hour,
unsigned char min,unsigned char sec,unsigned char hsec);
void rtc_get_alarm_date(unsigned char chip,unsigned char *date,
unsigned char *month);
void rtc_set_alarm_date(unsigned char chip,unsigned char date,
unsigned char month);

#pragma used-
#pragma library pcf8583_hw.lib

#endif

