;CodeVisionAVR C Compiler V1.24.5 Standard
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "ioctrl.vec"
	.INCLUDE "ioctrl.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /////////////////////////////////////////////////////////////////////////////
;       2 // NAME: ioctrl.c
;       3 // Funktion: gibt alle 10 Sekunden die Daten von 6 Maxim DS1820 (Temperatur-
;       4 // sensor) im csv-Format ber die serielle Schnittstelle aus. An diese ist
;       5 // ein RS-232 auf WLAN Adapter (WiPort von Lantronix) angeschlossen, mit des-
;       6 // sen Hilfe die Daten in das lokale Netz bzw. in das Internet eingespeist
;       7 // werden (Telnet Protokoll). Zustzlich werden die 6 Temperaturen auch noch
;       8 // auf einem angeschlossenen LCD-Display angezeigt. ber die RS-232 werden
;       9 // zustzlich zwei "virtuelle" Temperaturen mitgesendet. Die erste davon
;      10 // zeigt den Status der Umwlzpumpe der Gastherme an (wurde einfach mit ei-
;      11 // nem zur Pumpe parallelgeschalteten 230V Relais abgenommen) und zwar 20
;      12 // Grad fr Pumpe AUS und 40 Grad fr Pumpe EIN (siehe main()). Die zweite
;      13 // virtuelle Temperatur zeigt den Brennerstand an, 25 Grad = Brenner AUS,
;      14 // 39,8 Grad = Brenner EIN. Damit kann ich im Excel-Diagramm zusammen mit
;      15 // den Temperaturkurven auch die EIN/AUS-Stati von Pumpe und Brenner an-
;      16 // zeigen. Die Brennerflamme wurde brigens einfach mit einem Fototransistor
;      17 // dedektiert, dessen Signal vom Analogkomparator der ATmega16 ausgewertet
;      18 // wird (siehe main() ganz unten).
;      19 //
;      20 // Der Datenlogger wurden im Feber 2005 dazu verwendet, die Temperatur der
;      21 // Kche, des Vorlaufs und der vier Rcklufe der Heizungstherme aufzuzeich-
;      22 // nen. Als Hardware wurde ein "briggebliebenes" STK200 Evaluationboard von
;      23 // Kanda verwendet.
;      24 //
;      25 // Version: 1.00
;      26 // Start: 01.02.2005
;      27 // Author: Erwin Baeck                     
;      28 // Chip: ATmega16
;      29 // Clock: 16 MHz
;      30 /////////////////////////////////////////////////////////////////////////////
;      31 
;      32 #include <mega16.h>
;      33 #include <string.h>
;      34 #include <delay.h>
;      35 #include <stdio.h>
;      36 #include <math.h>
;      37 
;      38 // 1-Wire port definition
;      39 #asm
;      40 .equ __w1_port = 0x15
.equ __w1_port = 0x15
;      41 .equ __w1_bit = 5
.equ __w1_bit = 5
;      42 #endasm
;      43 
;      44 #include <ds1820.h>
___ds1820_scratch_pad:
	.BYTE 0x9
;      45 #include <1wire.h>
;      46 
;      47 #include "ioctrl.h"
;      48 #include "strings.h"
;      49 #include "lcd.h"
;      50 #include "irq.h"
;      51 
;      52 #define MAX_DEVICES 8
;      53 
;      54 eeprom UBYTE dummy = 0;

	.ESEG
_dummy:
	.DB  0x0
;      55 
;      56 //---------------------------------------------------------------------------
;      57 // Start des Programms
;      58 //---------------------------------------------------------------------------
;      59 void main(void)
;      60 {

	.CSEG
_main:
;      61 UBYTE rom_code[MAX_DEVICES,9];
;      62 UBYTE gLineBuffer[42];
;      63 UBYTE gLCDBuffer[6];
;      64 UBYTE devices = 0;
;      65 //UBYTE counter = 0;
;      66 UWORD temp;
;      67 UBYTE tmp;
;      68 UBYTE i,j;
;      69 
;      70 //---------------------------------------------------------------------------
;      71 // Port A initialization
;      72 //
;      73 // PORTA.0 = RS		44780-LCD
;      74 // PORTA.1 = R/-W	44780-LCD
;      75 // PORTA.2 = E		44780-LCD
;      76 // PORTA.4 = D4		44780-LCD
;      77 // PORTA.5 = D5		44780-LCD
;      78 // PORTA.6 = D6		44780-LCD
;      79 // PORTA.7 = D7		44780-LCD
;      80 //
;      81 //---------------------------------------------------------------------------
;      82 PORTA = 0b11111111;
	SBIW R28,63
	SBIW R28,57
;	rom_code -> Y+48
;	gLineBuffer -> Y+6
;	gLCDBuffer -> Y+0
;	devices -> R16
;	temp -> R17,R18
;	tmp -> R19
;	i -> R20
;	j -> R21
	LDI  R16,0
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;      83 DDRA  = 0b11110111;
	LDI  R30,LOW(247)
	OUT  0x1A,R30
;      84 
;      85 //---------------------------------------------------------------------------
;      86 // Port B initialization
;      87 //
;      88 // PORTB.0 = XCK/T0 = Umwlzpumpenrelais IN
;      89 // PORTB.1 = T1
;      90 // PORTB.2 = INT2/AIN0
;      91 // PORTB.3 = OC0/AIN1
;      92 // PORTB.4 = -SS
;      93 // PORTB.5 = MOSI
;      94 // PORTB.6 = MISO
;      95 // PORTB.7 = SCK
;      96 //---------------------------------------------------------------------------
;      97 PORTB = 0b11110011;
	LDI  R30,LOW(243)
	OUT  0x18,R30
;      98 DDRB  = 0b00000000;
	LDI  R30,LOW(0)
	OUT  0x17,R30
;      99 
;     100 //---------------------------------------------------------------------------
;     101 // Port C initialization
;     102 //
;     103 // PORTC.0 = SCL
;     104 // PORTC.1 = SDA
;     105 // PORTC.2 = TCK
;     106 // PORTC.3 = TMS
;     107 // PORTC.4 = TD0
;     108 // PORTC.5 = TDI = 1-Wire Port
;     109 // PORTC.6 = TOSC1
;     110 // PORTC.7 = TOSC2
;     111 //---------------------------------------------------------------------------
;     112 PORTC = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x15,R30
;     113 DDRC  = 0b00100000;
	LDI  R30,LOW(32)
	OUT  0x14,R30
;     114 
;     115 //---------------------------------------------------------------------------
;     116 // Port D initialization
;     117 //
;     118 // PORTD.0 = RXD
;     119 // PORTD.1 = TXD
;     120 // PORTD.2 = INT0
;     121 // PORTD.3 = INT1
;     122 // PORTD.4 = OC1B
;     123 // PORTD.5 = OC1A
;     124 // PORTD.6 = ICP
;     125 // PORTD.7 = OC2
;     126 //---------------------------------------------------------------------------
;     127 PORTD = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     128 DDRD  = 0b10000000;
	LDI  R30,LOW(128)
	OUT  0x11,R30
;     129 
;     130 //---------------------------------------------------------------------------
;     131 // Timer/Counter 0 initialization
;     132 // Clock source: System Clock
;     133 // Clock value: 250,000 kHz
;     134 // Mode: Normal top=FFh
;     135 // OC0 output: Disconnected
;     136 //---------------------------------------------------------------------------
;     137 TCCR0 = 0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     138 TCNT0 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     139 OCR0  = 0x00;
	OUT  0x3C,R30
;     140 
;     141 //---------------------------------------------------------------------------
;     142 // Timer/Counter 1 initialization
;     143 // Clock source: System Clock
;     144 // Clock value: 16000,000 kHz
;     145 // Mode: Normal top=FFFFh
;     146 // OC1A output: Discon.
;     147 // OC1B output: Discon.
;     148 // Noise Canceler: Off
;     149 // Input Capture on Falling Edge
;     150 //---------------------------------------------------------------------------
;     151 TCCR1A = 0x00;
	OUT  0x2F,R30
;     152 TCCR1B = 0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     153 TCNT1H = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     154 TCNT1L = 0x00;
	OUT  0x2C,R30
;     155 OCR1AH = 0x00;
	OUT  0x2B,R30
;     156 OCR1AL = 0x00;
	OUT  0x2A,R30
;     157 OCR1BH = 0x00;
	OUT  0x29,R30
;     158 OCR1BL = 0x00;
	OUT  0x28,R30
;     159 
;     160 //---------------------------------------------------------------------------
;     161 // Timer/Counter 2 initialization
;     162 // Clock source: System Clock
;     163 // Clock value: 16000,000 kHz
;     164 // Mode: Normal top = FFh
;     165 // OC2 output: Disconnected
;     166 //---------------------------------------------------------------------------
;     167 ASSR = 0x00;
	OUT  0x22,R30
;     168 TCCR2 = 0x01;
	LDI  R30,LOW(1)
	OUT  0x25,R30
;     169 TCNT2 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     170 OCR2 = 0x00;
	OUT  0x23,R30
;     171 
;     172 //---------------------------------------------------------------------------
;     173 // External Interrupt(s) initialization
;     174 // INT0(PD2): Off
;     175 // INT1(PD3): Off
;     176 // INT2(PB2): Off
;     177 //---------------------------------------------------------------------------
;     178 GICR  |= 0b00000000;
	IN   R30,0x3B
	OUT  0x3B,R30
;     179 MCUCR  = 0b00000000;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     180 MCUCSR = 0b00000000;
	OUT  0x34,R30
;     181 GIFR   = 0b01000000;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     182 
;     183 //---------------------------------------------------------------------------
;     184 // Timer(s)/Counter(s) Interrupt(s) initialization
;     185 // T0 OVL: on
;     186 //---------------------------------------------------------------------------
;     187 TIMSK = 0b00000001;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     188 
;     189 //---------------------------------------------------------------------------
;     190 // USART initialization
;     191 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     192 // USART Receiver: On
;     193 // USART Transmitter: On
;     194 // USART Mode: Asynchronous
;     195 // USART Baud rate: 38400
;     196 //---------------------------------------------------------------------------
;     197 UCSRA = 0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     198 UCSRB = 0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     199 UCSRC = 0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     200 UBRRH = 0x00;	// 38400 Baud fr WiPort
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     201 UBRRL = 0x19;	// 38400 Baud fr WiPort
	LDI  R30,LOW(25)
	OUT  0x9,R30
;     202 
;     203 //---------------------------------------------------------------------------
;     204 // Analog Comparator initialization
;     205 // Analog Comparator: Off
;     206 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     207 // Analog Comparator Output: Off
;     208 //---------------------------------------------------------------------------
;     209 ACSR = 0x80;
	LDI  R30,LOW(128)
	CALL SUBOPT_0x0
;     210 SFIOR = 0x00;
;     211 
;     212 //---------------------------------------------------------------------------
;     213 // ADC initialization
;     214 // ADC Clock frequency: 125,000 kHz
;     215 // ADC Voltage Reference: AREF pin
;     216 // ADC High Speed Mode: Off
;     217 // ADC Auto Trigger Source: Free Running
;     218 //---------------------------------------------------------------------------
;     219 ADMUX	= 0b00000000;	//use external reference + ADC3
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     220 ADCSRA	= 0b10000111;	//ADC enabled, no IRQ, clk/128
	LDI  R30,LOW(135)
	OUT  0x6,R30
;     221 SFIOR  &= 0b11101111;	//fast conversion off
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
;     222 
;     223 //---------------------------------------------------------------------------
;     224 // SPI initialization
;     225 // SPI Type: none
;     226 // SPI Clock Rate: 4000,000 kHz
;     227 // SPI Clock Phase: Cycle Half
;     228 // SPI Clock Polarity: Low
;     229 // SPI Data Order: MSB First
;     230 //---------------------------------------------------------------------------
;     231 SPCR = 0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
;     232 SPSR = 0x00;
	OUT  0xE,R30
;     233 
;     234 //---------------------------------------------------------------------------
;     235 // 2 Wire Bus initialization
;     236 // Generate Acknowledge Pulse: Off
;     237 // 2 Wire Bus Slave Address: 0h
;     238 // General Call Recognition: Off
;     239 // Bit Rate: 100,000 kHz
;     240 //---------------------------------------------------------------------------
;     241 TWBR = 0x48;
	LDI  R30,LOW(72)
	OUT  0x0,R30
;     242 TWAR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
;     243 TWCR = 0x04;
	LDI  R30,LOW(4)
	OUT  0x36,R30
;     244 
;     245 //---------------------------------------------------------------------------
;     246 // Analog Comparator initialization
;     247 // Analog Comparator: On
;     248 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     249 //---------------------------------------------------------------------------
;     250 ACSR  = 0x00;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x0
;     251 SFIOR = 0x00;
;     252 
;     253 
;     254 //---------------------------------------------------------------------------
;     255 // Clear the SPI interrupt flag
;     256 //---------------------------------------------------------------------------
;     257 #asm
;     258 in   r30,spsr
in   r30,spsr
;     259 in   r30,spdr
in   r30,spdr
;     260 #endasm
;     261 
;     262 //---------------------------------------------------------------------------
;     263 // Display initialisieren
;     264 //---------------------------------------------------------------------------
;     265 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     266 
;     267 //---------------------------------------------------------------------------
;     268 // Resettext anzeigen
;     269 //---------------------------------------------------------------------------
;     270 for(i = 0; i < 16; i++)	lcd_putchar(STRINGSLcdHeader1[i]);
	LDI  R20,LOW(0)
_0x4:
	CPI  R20,16
	BRSH _0x5
	MOV  R30,R20
	LDI  R31,0
	SUBI R30,LOW(-_STRINGSLcdHeader1)
	SBCI R31,HIGH(-_STRINGSLcdHeader1)
	CALL SUBOPT_0x1
;     271 lcd_gotoxy(0,1);
	SUBI R20,-1
	RJMP _0x4
_0x5:
	CALL SUBOPT_0x2
;     272 for(i = 0; i < 16; i++)	lcd_putchar(STRINGSLcdHeader2[i]);
	LDI  R20,LOW(0)
_0x7:
	CPI  R20,16
	BRSH _0x8
	MOV  R30,R20
	LDI  R31,0
	SUBI R30,LOW(-_STRINGSLcdHeader2)
	SBCI R31,HIGH(-_STRINGSLcdHeader2)
	CALL SUBOPT_0x1
;     273 
;     274 printf("\n\n\rRESET!\n\n\r");
	SUBI R20,-1
	RJMP _0x7
_0x8:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     275 
;     276 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     277 
;     278 INT_ON;		// enable interrupts
	sei
;     279 
;     280 memset(gLineBuffer,0x00,sizeof(gLineBuffer));
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	ST   -Y,R31
	ST   -Y,R30
	CALL _memset
;     281 
;     282 printf("Suche 1-Wire Devices .... ");
	__POINTW1FN _0,13
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     283 
;     284 // DS1820 am Bus suchen ...
;     285 devices = w1_search(0xf0,rom_code);
	LDI  R30,LOW(240)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,49
	ST   -Y,R31
	ST   -Y,R30
	CALL _w1_search
	MOV  R16,R30
;     286 
;     287 // ... und gefundene Menge anzeigen
;     288 printf("%d DS182x gefunden!\n\n\r",devices);
	__POINTW1FN _0,40
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     289 
;     290 // ROM-Codes der gefundenen DS1820 anzeigen
;     291 if (devices)
	CPI  R16,0
	BRNE PC+3
	JMP _0x9
;     292 	{
;     293 	for (i = 0; i < devices; i++)
	LDI  R20,LOW(0)
_0xB:
	CP   R20,R16
	BRSH _0xC
;     294 		{
;     295 		printf("ROM-Code DS182x_%02d: ",i+1);
	__POINTW1FN _0,63
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R20
	SUBI R30,-LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     296 
;     297 		for (j = 0; j < 8; j++) printf("%02X ",rom_code[i,j]);
	LDI  R21,LOW(0)
_0xE:
	CPI  R21,8
	BRSH _0xF
	__POINTW1FN _0,86
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x3
	MOVW R26,R28
	ADIW R26,50
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R21
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     298 
;     299 		PCRLF;
	SUBI R21,-1
	RJMP _0xE
_0xF:
	__POINTW1FN _0,10
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
;     300 		}
	SUBI R20,-1
	RJMP _0xB
_0xC:
;     301 	PCRLF;
	__POINTW1FN _0,10
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0xB1
;     302 	}
;     303 else
_0x9:
;     304 	{
;     305 	printf("Keinen DS182x gefunden!\n\n\r");
	__POINTW1FN _0,92
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0xB1:
	CALL _printf
	ADIW R28,2
;     306 	}
;     307 
;     308 lcd_clear();
	CALL _lcd_clear
;     309 
;     310 //---------------------------------------------------------------------------
;     311 // Start der Hauptschleife
;     312 //---------------------------------------------------------------------------
;     313 // Anschlussreihenfolge der Sensoren:
;     314 //
;     315 // Sensor 1 = ROM-Code 1 = INNEN
;     316 // Sensor 2 = ROM-Code 3 = VORLAUF
;     317 // Sensor 3 = ROM-Code 5 = Schlafzimmer
;     318 // Sensor 4 = ROM-Code 4 = Wohnzimmer
;     319 // Sensor 5 = ROM-Code 0 = Bad
;     320 // Sensor 6 = ROM-Code 2 = Kche
;     321 //---------------------------------------------------------------------------
;     322 while(1)
_0x11:
;     323 	{
;     324 //	sprintf(&gLineBuffer[0],"%03d,",counter);
;     325 
;     326 	giMSecTimer = 0;	// reset 10 sec timer
	LDI  R30,0
	STS  _giMSecTimer,R30
	STS  _giMSecTimer+1,R30
;     327 
;     328 	for(i = 0; i < devices; i++)
	LDI  R20,LOW(0)
_0x15:
	CP   R20,R16
	BRLO PC+3
	JMP _0x16
;     329 		{
;     330 		LED_ON;
	CBI  0x18,2
;     331 		temp = ds1820_temperature_10(&rom_code[i,0]);
	CALL SUBOPT_0x3
	MOVW R26,R28
	ADIW R26,48
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	CALL _ds1820_temperature_10
	__PUTW1R 17,18
;     332 		LED_OFF;
	SBI  0x18,2
;     333 
;     334 		switch(i + 1)
	MOV  R30,R20
	SUBI R30,-LOW(1)
;     335 			{
;     336 			case 1:
	CPI  R30,LOW(0x1)
	BRNE _0x1A
;     337 			// Sensor 5 = ROM-Code 0 = Bad
;     338 //			printf("%05d ",temp);
;     339 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x1B
;     340 				{
;     341 				sprintf(&gLineBuffer[20],"00.0,");	// 5
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x4
;     342 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB2
;     343 				}
;     344 			else
_0x1B:
;     345 				{
;     346 				sprintf(&gLineBuffer[20],"%02i.%u,",temp/10,temp%10);	// 5
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL SUBOPT_0x7
;     347 				sprintf(gLCDBuffer,"%03d,",temp);
	__POINTW1FN _0,138
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB2:
	CALL _sprintf
	ADIW R28,8
;     348 				}
;     349 			lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x8
;     350 			break;
	RJMP _0x19
;     351 
;     352 			case 2:
_0x1A:
	CPI  R30,LOW(0x2)
	BRNE _0x1D
;     353 			// Sensor 1 = ROM-Code 1 = tRaum
;     354 //			printf("%05d ",temp);
;     355 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x1E
;     356 				{
;     357 				sprintf(&gLineBuffer[0],"00.0,");	// 5
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x4
;     358 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB3
;     359 				}
;     360 			else
_0x1E:
;     361 				{
;     362 				sprintf(&gLineBuffer[0],"%02i.%u,",temp/10,temp%10);	// 5
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL SUBOPT_0x7
;     363 				sprintf(gLCDBuffer,"%03d",temp);
	__POINTW1FN _0,144
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB3:
	CALL _sprintf
	ADIW R28,8
;     364 				}
;     365 			lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x9
;     366 			break;
	RJMP _0x19
;     367 
;     368 			case 3:
_0x1D:
	CPI  R30,LOW(0x3)
	BRNE _0x20
;     369 			// Sensor 6 = ROM-Code 2 = Kche
;     370 //			printf("%05d ",temp);
;     371 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x21
;     372 				{
;     373 				sprintf(&gLineBuffer[25],"00.0,");	// 6
	MOVW R30,R28
	ADIW R30,31
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x4
;     374 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB4
;     375 				}
;     376 			else
_0x21:
;     377 				{
;     378 				sprintf(&gLineBuffer[25],"%02i.%u,",temp/10,temp%10);	// 6
	MOVW R30,R28
	ADIW R30,31
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL SUBOPT_0x7
;     379 				sprintf(gLCDBuffer,"%03d",temp);
	__POINTW1FN _0,144
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB4:
	CALL _sprintf
	ADIW R28,8
;     380 				}
;     381 			lcd_gotoxy(12,1);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x8
;     382 			break;
	RJMP _0x19
;     383 
;     384 			case 4:
_0x20:
	CPI  R30,LOW(0x4)
	BRNE _0x23
;     385 			// Sensor 2 = ROM-Code 3 = Vorlauf
;     386 //			printf("%05d ",temp);
;     387 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x24
;     388 				{
;     389 				sprintf(&gLineBuffer[5],"00.0,");	// 5
	MOVW R30,R28
	ADIW R30,11
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x4
;     390 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB5
;     391 				}
;     392 			else
_0x24:
;     393 				{
;     394 				sprintf(&gLineBuffer[5],"%02i.%u,",temp/10,temp%10);	// 5
	MOVW R30,R28
	ADIW R30,11
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL SUBOPT_0x7
;     395 				sprintf(gLCDBuffer,"%03d",temp);
	__POINTW1FN _0,144
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB5:
	CALL _sprintf
	ADIW R28,8
;     396 				}
;     397 			lcd_gotoxy(6,0);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x9
;     398 			break;
	RJMP _0x19
;     399 
;     400 			case 5:
_0x23:
	CPI  R30,LOW(0x5)
	BRNE _0x26
;     401 			// Sensor 4 = ROM-Code 4 = Wohnzimmer
;     402 //			printf("%05d ",temp);
;     403 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x27
;     404 				{
;     405 				tmp = gLineBuffer[20];
	LDD  R19,Y+26
;     406 				sprintf(&gLineBuffer[15],"00.0,");	// 5
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     407 				gLineBuffer[20] = tmp;
	CALL SUBOPT_0xA
;     408 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB6
;     409 				}
;     410 			else
_0x27:
;     411 				{
;     412 				tmp = gLineBuffer[20];
	LDD  R19,Y+26
;     413 				sprintf(&gLineBuffer[15],"%02i.%u,",temp/10,temp%10);	// 5
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;     414 				gLineBuffer[20] = tmp;
	CALL SUBOPT_0xA
;     415 				sprintf(gLCDBuffer,"%03d",temp);
	__POINTW1FN _0,144
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB6:
	CALL _sprintf
	ADIW R28,8
;     416 				}
;     417 			lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
;     418 			break;
	RJMP _0x19
;     419 
;     420 			case 6:
_0x26:
	CPI  R30,LOW(0x6)
	BRNE _0x19
;     421 			// Sensor 3 = ROM-Code 5 = Schlafzimmer
;     422 //			printf("%05d\n\r",temp);
;     423 			if(temp == -9999)
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	CP   R30,R17
	CPC  R31,R18
	BRNE _0x2A
;     424 				{
;     425 				tmp = gLineBuffer[15];
	LDD  R19,Y+21
;     426 				sprintf(&gLineBuffer[10],"00.0,");	// 5
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     427 				gLineBuffer[15] = tmp;
	CALL SUBOPT_0xB
;     428 				sprintf(gLCDBuffer,"000",temp);
	__POINTW1FN _0,125
	CALL SUBOPT_0x5
	LDI  R24,4
	RJMP _0xB7
;     429 				}
;     430 			else
_0x2A:
;     431 				{
;     432 				tmp = gLineBuffer[15];
	LDD  R19,Y+21
;     433 				sprintf(&gLineBuffer[10],"%02i.%u,",temp/10,temp%10);	// 5
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,129
	CALL SUBOPT_0x6
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;     434 				gLineBuffer[15] = tmp;
	CALL SUBOPT_0xB
;     435 				sprintf(gLCDBuffer,"%03d",temp);
	__POINTW1FN _0,144
	CALL SUBOPT_0x5
	LDI  R24,4
_0xB7:
	CALL _sprintf
	ADIW R28,8
;     436 				}
;     437 			lcd_gotoxy(12,0);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x9
;     438 			break;
;     439 			}
_0x19:
;     440 		//-------------------------------------------------------------------
;     441 		// Nchsten LCD-Wert anzeigen
;     442 		//-------------------------------------------------------------------
;     443 		lcd_putchar(gLCDBuffer[0]);
	LD   R30,Y
	ST   -Y,R30
	CALL _lcd_putchar
;     444 		lcd_putchar(gLCDBuffer[1]);
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _lcd_putchar
;     445 		lcd_putchar('.');
	LDI  R30,LOW(46)
	ST   -Y,R30
	CALL _lcd_putchar
;     446 		lcd_putchar(gLCDBuffer[2]);
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _lcd_putchar
;     447 		}
	SUBI R20,-1
	RJMP _0x15
_0x16:
;     448 
;     449 	//-----------------------------------------------------------------------
;     450 	// Pumpenrelais auswerten
;     451 	//-----------------------------------------------------------------------
;     452 	if(PINB.0)
	SBIS 0x16,0
	RJMP _0x2C
;     453 		{
;     454 		sprintf(&gLineBuffer[30],"20.0,");
	MOVW R30,R28
	ADIW R30,36
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,149
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0xC
;     455 		lcd_gotoxy(4,0);
;     456 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     457 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     458 		lcd_gotoxy(10,0);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x9
;     459 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     460 		lcd_putchar(SPC);
	LDI  R30,LOW(32)
	RJMP _0xB8
;     461 		}
;     462 	else
_0x2C:
;     463 		{
;     464 		sprintf(&gLineBuffer[30],"40.0,");
	MOVW R30,R28
	ADIW R30,36
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,155
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0xC
;     465 		lcd_gotoxy(4,0);
;     466 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     467 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     468 		lcd_gotoxy(10,0);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x9
;     469 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     470 		lcd_putchar('*');
	LDI  R30,LOW(42)
_0xB8:
	ST   -Y,R30
	CALL _lcd_putchar
;     471 		}
;     472 
;     473 	//-----------------------------------------------------------------------
;     474 	// Analog Komparator auswerten (Brennerstart)
;     475 	//-----------------------------------------------------------------------
;     476 	if(ACSR & 0b00100000)
	SBIS 0x8,5
	RJMP _0x2E
;     477 		{
;     478 		sprintf(&gLineBuffer[35],"39.8\n\r");
	MOVW R30,R28
	ADIW R30,41
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,161
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0xF
;     479 		lcd_gotoxy(4,1);
;     480 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     481 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     482 		lcd_gotoxy(10,1);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x8
;     483 		lcd_putchar('*');
	CALL SUBOPT_0xE
;     484 		lcd_putchar('*');
	LDI  R30,LOW(42)
	RJMP _0xB9
;     485 		}
;     486 	else
_0x2E:
;     487 		{
;     488 		sprintf(&gLineBuffer[35],"25.0\n\r");
	MOVW R30,R28
	ADIW R30,41
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,168
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0xF
;     489 		lcd_gotoxy(4,1);
;     490 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     491 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     492 		lcd_gotoxy(10,1);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x8
;     493 		lcd_putchar(SPC);
	CALL SUBOPT_0xD
;     494 		lcd_putchar(SPC);
	LDI  R30,LOW(32)
_0xB9:
	ST   -Y,R30
	CALL _lcd_putchar
;     495 		}
;     496 
;     497 	//-----------------------------------------------------------------------
;     498 	// String auf RS-232 ausgeben
;     499 	//-----------------------------------------------------------------------
;     500 	for(i = 0; i < sizeof(gLineBuffer); i++) putchar(gLineBuffer[i]);
	LDI  R20,LOW(0)
_0x31:
	CPI  R20,42
	BRSH _0x32
	MOV  R30,R20
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _putchar
;     501 
;     502 //	counter++;
;     503 
;     504 //	delay_ms(7000);	// alle 10 sec eine Messung
;     505 
;     506 	while(giMSecTimer < 10000);
	SUBI R20,-1
	RJMP _0x31
_0x32:
_0x33:
	LDS  R26,_giMSecTimer
	LDS  R27,_giMSecTimer+1
	CPI  R26,LOW(0x2710)
	LDI  R30,HIGH(0x2710)
	CPC  R27,R30
	BRLO _0x33
;     507 	}
	RJMP _0x11
;     508 }
	ADIW R28,63
	ADIW R28,57
_0x36:
	RJMP _0x36
;     509 
;     510 /////////////////////////////////////////////////////////////////////////////
;     511 // Ende von ioctrl.c
;     512 /////////////////////////////////////////////////////////////////////////////
;     513 /////////////////////////////////////////////////////////////////////////////
;     514 // NAME: irq.c
;     515 // FUNKTION: Enthlt die Interrupt Service Routinen
;     516 // ERSTELLT: 02/2004 - Erwin Baeck
;     517 /////////////////////////////////////////////////////////////////////////////
;     518 
;     519 #include <mega16.h>
;     520 #include "globals.h"
;     521 
;     522 //---------------------------------------------------------------------------
;     523 // Globals
;     524 //---------------------------------------------------------------------------
;     525 UWORD giMSecTimer;

	.DSEG
_giMSecTimer:
	.BYTE 0x2
;     526 UWORD gADCData;
_gADCData:
	.BYTE 0x2
;     527 bit gADCComplete;
;     528 
;     529 //---------------------------------------------------------------------------
;     530 // External Interrupt 0 service routine
;     531 //---------------------------------------------------------------------------
;     532 interrupt [EXT_INT0] void ext_int0_isr(void)
;     533 {

	.CSEG
_ext_int0_isr:
;     534 // Place your code here
;     535 
;     536 }
	RETI
;     537 
;     538 //---------------------------------------------------------------------------
;     539 // External Interrupt 1 service routine
;     540 //---------------------------------------------------------------------------
;     541 interrupt [EXT_INT1] void ext_int1_isr(void)
;     542 {
_ext_int1_isr:
;     543 // Place your code here
;     544 
;     545 }
	RETI
;     546 
;     547 //---------------------------------------------------------------------------
;     548 // External Interrupt 2 service routine
;     549 //---------------------------------------------------------------------------
;     550 interrupt [EXT_INT2] void ext_int2_isr(void)
;     551 {
_ext_int2_isr:
;     552 // Place your code here
;     553 
;     554 }
	RETI
;     555 
;     556 #define RXB8 1
;     557 #define TXB8 0
;     558 #define UPE 2
;     559 #define OVR 3
;     560 #define FE 4
;     561 #define UDRE 5
;     562 #define RXC 7
;     563 
;     564 #define FRAMING_ERROR (1<<FE)
;     565 #define PARITY_ERROR (1<<UPE)
;     566 #define DATA_OVERRUN (1<<OVR)
;     567 #define DATA_REGISTER_EMPTY (1<<UDRE)
;     568 #define RX_COMPLETE (1<<RXC)
;     569 
;     570 //---------------------------------------------------------------------------
;     571 // USART Receiver buffer
;     572 //---------------------------------------------------------------------------
;     573 #define RX_BUFFER_SIZE 248
;     574 char rx_buffer[RX_BUFFER_SIZE];

	.DSEG
_rx_buffer:
	.BYTE 0xF8
;     575 unsigned char rx_wr_index,rx_rd_index,rx_counter;
;     576 
;     577 //---------------------------------------------------------------------------
;     578 // This flag is set on USART Receiver buffer overflow
;     579 //---------------------------------------------------------------------------
;     580 bit rx_buffer_overflow;
;     581 
;     582 //---------------------------------------------------------------------------
;     583 // USART Receiver interrupt service routine
;     584 //---------------------------------------------------------------------------
;     585 #pragma savereg-
;     586 interrupt [USART_RXC] void uart_rx_isr(void)
;     587 {

	.CSEG
_uart_rx_isr:
;     588 char status,data;
;     589 #asm
	ST   -Y,R17
	ST   -Y,R16
;	status -> R16
;	data -> R17
;     590     push r26
    push r26
;     591     push r27
    push r27
;     592     push r30
    push r30
;     593     push r31
    push r31
;     594     in   r26,sreg
    in   r26,sreg
;     595     push r26
    push r26
;     596 #endasm
;     597 status=UCSRA;
	IN   R16,11
;     598 data=UDR;
	IN   R17,12
;     599 
;     600 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BRNE _0x37
;     601    {
;     602    rx_buffer[rx_wr_index]=data;
	MOV  R26,R4
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer)
	SBCI R27,HIGH(-_rx_buffer)
	ST   X,R17
;     603    if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	INC  R4
	LDI  R30,LOW(248)
	CP   R30,R4
	BRNE _0x38
	CLR  R4
;     604    if (++rx_counter == RX_BUFFER_SIZE)
_0x38:
	INC  R6
	LDI  R30,LOW(248)
	CP   R30,R6
	BRNE _0x39
;     605       {
;     606       rx_counter=0;
	CLR  R6
;     607       rx_buffer_overflow=1;
	SET
	BLD  R2,1
;     608       };
_0x39:
;     609    };
_0x37:
;     610 #asm
;     611     pop  r26
    pop  r26
;     612     out  sreg,r26
    out  sreg,r26
;     613     pop  r31
    pop  r31
;     614     pop  r30
    pop  r30
;     615     pop  r27
    pop  r27
;     616     pop  r26
    pop  r26
;     617 #endasm
;     618 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     619 #pragma savereg+
;     620 
;     621 #ifndef _DEBUG_TERMINAL_IO_
;     622 //---------------------------------------------------------------------------
;     623 // Get a character from the USART Receiver buffer
;     624 //---------------------------------------------------------------------------
;     625 #define _ALTERNATE_GETCHAR_
;     626 #pragma used+
;     627 char getchar(void)
;     628 {
;     629 char data;
;     630 while (rx_counter==0);
;	data -> R16
;     631 data=rx_buffer[rx_rd_index];
;     632 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
;     633 #asm("cli")
;     634 --rx_counter;
;     635 #asm("sei")
;     636 return data;
;     637 }
;     638 #pragma used-
;     639 #endif
;     640 
;     641 //---------------------------------------------------------------------------
;     642 // Standard Input/Output functions
;     643 //---------------------------------------------------------------------------
;     644 #include <stdio.h>
;     645 
;     646 //===========================================================================
;     647 // Timer 0 overflow interrupt service routine
;     648 //===========================================================================
;     649 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     650 {
_timer0_ovf_isr:
	CALL SUBOPT_0x10
;     651 TCNT0 = 0x06;	// reinitialize T0 for a period of 1 msec
	LDI  R30,LOW(6)
	OUT  0x32,R30
;     652 
;     653 giMSecTimer++;
	LDS  R30,_giMSecTimer
	LDS  R31,_giMSecTimer+1
	ADIW R30,1
	STS  _giMSecTimer,R30
	STS  _giMSecTimer+1,R31
;     654 }
	CALL SUBOPT_0x11
	RETI
;     655 
;     656 //---------------------------------------------------------------------------
;     657 // Timer 1 overflow interrupt service routine
;     658 //---------------------------------------------------------------------------
;     659 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     660 {
_timer1_ovf_isr:
;     661 // Place your code here
;     662 
;     663 }
	RETI
;     664 
;     665 //---------------------------------------------------------------------------
;     666 // Timer 2 overflow interrupt service routine
;     667 //---------------------------------------------------------------------------
;     668 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     669 {
_timer2_ovf_isr:
;     670 // Place your code here
;     671 
;     672 }
	RETI
;     673 
;     674 //---------------------------------------------------------------------------
;     675 // ADC interrupt service routine
;     676 //---------------------------------------------------------------------------
;     677 interrupt [ADC_INT] void adc_isr(void)
;     678 {
_adc_isr:
	CALL SUBOPT_0x10
;     679 gADCData = ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _gADCData,R30
	STS  _gADCData+1,R31
;     680 gADCComplete = TRUE;
	SET
	BLD  R2,0
;     681 }
	CALL SUBOPT_0x11
	RETI
;     682 
;     683 //---------------------------------------------------------------------------
;     684 // SPI interrupt service routine
;     685 //---------------------------------------------------------------------------
;     686 interrupt [SPI_STC] void spi_isr(void)
;     687 {
_spi_isr:
;     688 unsigned char data;
;     689 data = SPDR;
	ST   -Y,R16
;	data -> R16
	IN   R16,15
;     690 // Place your code here
;     691 
;     692 }
	LD   R16,Y+
	RETI
;     693 
;     694 /////////////////////////////////////////////////////////////////////////////
;     695 // Ende von irq.c
;     696 /////////////////////////////////////////////////////////////////////////////
;     697 /////////////////////////////////////////////////////////////////////////////
;     698 // NAME: lcd.c
;     699 // FUNKTION: LCD Treiber
;     700 //---------------------------------------------------------------------------
;     701 // Anschlsse des 2x16 LCD:
;     702 //
;     703 // RS		= PORTA.0
;     704 // R/-W		= PORTA.1
;     705 // E		= PORTA.2
;     706 // D4 - D7	= PORTA.4 - PORTA.7
;     707 /////////////////////////////////////////////////////////////////////////////
;     708 
;     709 static unsigned char _base_y[4] = {0x80,0xc0};

	.DSEG
__base_y_G3:
	.BYTE 0x4
;     710 
;     711 #asm
;     712 	.equ __lcd_port = 0x1B
	.equ __lcd_port = 0x1B
;     713     .equ __lcd_direction = __lcd_port-1
    .equ __lcd_direction = __lcd_port-1
;     714     .equ __lcd_pin = __lcd_port-2
    .equ __lcd_pin = __lcd_port-2
;     715     .equ __lcd_rs = 0
    .equ __lcd_rs = 0
;     716     .equ __lcd_rd = 1
    .equ __lcd_rd = 1
;     717     .equ __lcd_enable = 2
    .equ __lcd_enable = 2
;     718     .equ __lcd_busy_flag = 7
    .equ __lcd_busy_flag = 7
;     719 #endasm
;     720 
;     721 unsigned char _lcd_x,_lcd_y,_lcd_maxx;
;     722 
;     723 void _lcd_ready(void)
;     724 {

	.CSEG
__lcd_ready:
;     725 #asm
;     726     in    r26,__lcd_direction
    in    r26,__lcd_direction
;     727     andi  r26,0xf                 ;set as input
    andi  r26,0xf                 ;set as input
;     728     out   __lcd_direction,r26
    out   __lcd_direction,r26
;     729     sbi   __lcd_port,__lcd_rd     ;RD = 1
    sbi   __lcd_port,__lcd_rd     ;RD = 1
;     730     cbi   __lcd_port,__lcd_rs     ;RS = 0
    cbi   __lcd_port,__lcd_rs     ;RS = 0
;     731 __lcd_busy:
__lcd_busy:
;     732     rcall __lcd_delay
    rcall __lcd_delay
;     733     sbi   __lcd_port,__lcd_enable ;EN = 1
    sbi   __lcd_port,__lcd_enable ;EN = 1
;     734     rcall __lcd_delay
    rcall __lcd_delay
;     735     sbic  __lcd_pin,__lcd_busy_flag
    sbic  __lcd_pin,__lcd_busy_flag
;     736     rjmp  __lcd_busy
    rjmp  __lcd_busy
;     737     cbi   __lcd_port,__lcd_enable ;EN = 0
    cbi   __lcd_port,__lcd_enable ;EN = 0
;     738 #endasm
;     739 }
	RET
;     740 
;     741 #asm
;     742 __lcd_write_nibble:
__lcd_write_nibble:
;     743     andi  r26,0xf0
    andi  r26,0xf0
;     744     or    r26,r27
    or    r26,r27
;     745     out   __lcd_port,r26          ;write
    out   __lcd_port,r26          ;write
;     746     sbi   __lcd_port,__lcd_enable ;EN = 1
    sbi   __lcd_port,__lcd_enable ;EN = 1
;     747     rcall __lcd_delay
    rcall __lcd_delay
;     748     cbi   __lcd_port,__lcd_enable ;EN = 0
    cbi   __lcd_port,__lcd_enable ;EN = 0
;     749 __lcd_delay:
__lcd_delay:
;     750     nop
    nop
;     751     nop
    nop
;     752     nop
    nop
;     753     nop
    nop
;     754     nop
    nop
;     755     nop
    nop
;     756     ret
    ret
;     757 #endasm
;     758 
;     759 void _lcd_write_data(unsigned char data)
;     760 {
__lcd_write_data:
;     761 #asm
;     762     cbi  __lcd_port,__lcd_rd 	  ;RD = 0
    cbi  __lcd_port,__lcd_rd 	  ;RD = 0
;     763     in    r26,__lcd_direction
    in    r26,__lcd_direction
;     764     ori   r26,0xf7                ;set as output
    ori   r26,0xf7                ;set as output
;     765     out   __lcd_direction,r26
    out   __lcd_direction,r26
;     766     in    r27,__lcd_port
    in    r27,__lcd_port
;     767     andi  r27,0xf
    andi  r27,0xf
;     768     ld    r26,y
    ld    r26,y
;     769     rcall __lcd_write_nibble      ;RD = 0, write MSN
    rcall __lcd_write_nibble      ;RD = 0, write MSN
;     770     ld    r26,y
    ld    r26,y
;     771     swap  r26
    swap  r26
;     772     rcall __lcd_write_nibble      ;write LSN
    rcall __lcd_write_nibble      ;write LSN
;     773     sbi   __lcd_port,__lcd_rd     ;RD = 1
    sbi   __lcd_port,__lcd_rd     ;RD = 1
;     774 #endasm
;     775 }
	ADIW R28,1
	RET
;     776 
;     777 //---------------------------------------------------------------------------
;     778 // write a byte to the LCD character generator or display RAM
;     779 //---------------------------------------------------------------------------
;     780 void lcd_write_byte(unsigned char addr, unsigned char data)
;     781 {
;     782 _lcd_ready();
;     783 _lcd_write_data(addr);
;     784 _lcd_ready();
;     785 #asm
;     786     sbi   __lcd_port,__lcd_rs     ;RS = 1
;     787 #endasm
;     788 _lcd_write_data(data);
;     789 }
;     790 
;     791 #asm
;     792 __lcd_read_nibble:
__lcd_read_nibble:
;     793     sbi   __lcd_port,__lcd_enable ;EN = 1
    sbi   __lcd_port,__lcd_enable ;EN = 1
;     794     rcall __lcd_delay
    rcall __lcd_delay
;     795     in    r30,__lcd_pin           ;read
    in    r30,__lcd_pin           ;read
;     796     cbi   __lcd_port,__lcd_enable ;EN = 0
    cbi   __lcd_port,__lcd_enable ;EN = 0
;     797     rcall __lcd_delay
    rcall __lcd_delay
;     798     andi  r30,0xf0
    andi  r30,0xf0
;     799     ret
    ret
;     800 #endasm
;     801 
;     802 //---------------------------------------------------------------------------
;     803 // read a byte from the LCD character generator or display RAM
;     804 //---------------------------------------------------------------------------
;     805 unsigned char lcd_read_byte(unsigned char addr)
;     806 {
;     807 _lcd_ready();
;     808 _lcd_write_data(addr);
;     809 _lcd_ready();
;     810 
;     811 #asm
;     812     in    r26,__lcd_direction
;     813     andi  r26,0xf                 ;set as input
;     814     out   __lcd_direction,r26
;     815     sbi   __lcd_port,__lcd_rs     ;RS = 1
;     816     rcall __lcd_delay
;     817     rcall __lcd_read_nibble       ;read MSN
;     818     mov   r26,r30
;     819     rcall __lcd_read_nibble       ;read LSN
;     820     cbi   __lcd_port,__lcd_rd     ;RD = 0
;     821     swap  r30
;     822     or    r30,r26
;     823 #endasm
;     824 }
;     825 
;     826 //---------------------------------------------------------------------------
;     827 // set the LCD display position x = 0..39 y = 0..3
;     828 //---------------------------------------------------------------------------
;     829 void lcd_gotoxy(unsigned char x, unsigned char y)
;     830 {
_lcd_gotoxy:
;     831 _lcd_ready(); // RS = 0
	CALL __lcd_ready
;     832 _lcd_write_data(_base_y[y]+x);
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
;     833 _lcd_x = x;
	LDD  R7,Y+1
;     834 _lcd_y = y;
	LDD  R8,Y+0
;     835 }
	ADIW R28,2
	RET
;     836 
;     837 //---------------------------------------------------------------------------
;     838 // clear the LCD
;     839 //---------------------------------------------------------------------------
;     840 void lcd_clear(void)
;     841 {
_lcd_clear:
;     842 _lcd_ready();         // RS = 0
	CALL __lcd_ready
;     843 _lcd_write_data(0xc); // cursor off
	LDI  R30,LOW(12)
	CALL SUBOPT_0x12
;     844 _lcd_ready();
;     845 _lcd_write_data(1);   // clear
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
;     846 _lcd_x = _lcd_y = 0;
	LDI  R30,LOW(0)
	MOV  R8,R30
	MOV  R7,R30
;     847 }
	RET
;     848 
;     849 #pragma keep+
;     850 void lcd_putchar(char c)
;     851 {
_lcd_putchar:
;     852 #asm
;     853     push r30
    push r30
;     854     push r31
    push r31
;     855     ld   r26,y
    ld   r26,y
;     856     set
    set
;     857     cpi  r26,10
    cpi  r26,10
;     858     breq __lcd_putchar1
    breq __lcd_putchar1
;     859     clt
    clt
;     860 #endasm
;     861 ++_lcd_x;
	INC  R7
;     862 if (_lcd_x>_lcd_maxx)
	CP   R9,R7
	BRSH _0x3F
;     863    {
;     864    #asm("__lcd_putchar1:")
	__lcd_putchar1:
;     865    ++_lcd_y;
	INC  R8
;     866    lcd_gotoxy(0,_lcd_y);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R8
	CALL _lcd_gotoxy
;     867    #asm("brts __lcd_putchar0")
	brts __lcd_putchar0
;     868    };
_0x3F:
;     869 #asm
;     870     rcall __lcd_ready
    rcall __lcd_ready
;     871     sbi  __lcd_port,__lcd_rs ;RS = 1
    sbi  __lcd_port,__lcd_rs ;RS = 1
;     872     ld   r26,y
    ld   r26,y
;     873     st   -y,r26
    st   -y,r26
;     874     rcall __lcd_write_data
    rcall __lcd_write_data
;     875 __lcd_putchar0:
__lcd_putchar0:
;     876     pop  r31
    pop  r31
;     877     pop  r30
    pop  r30
;     878 #endasm
;     879 }
	ADIW R28,1
	RET
;     880 #pragma keep-
;     881 
;     882 //---------------------------------------------------------------------------
;     883 // write the string str located in SRAM to the LCD
;     884 //---------------------------------------------------------------------------
;     885 void lcd_puts(char *str)
;     886 {
;     887 #asm
;     888     ldd  r31,y+1
;     889 #endasm
;     890 
;     891 #asm
;     892     ld   r30,y
;     893 __lcd_puts0:
;     894     ld   r26,z+
;     895     tst  r26
;     896     breq __lcd_puts1
;     897     st   -y,r26    
;     898     rcall _lcd_putchar
;     899     rjmp __lcd_puts0
;     900 __lcd_puts1:
;     901 #endasm
;     902 }
;     903 
;     904 //---------------------------------------------------------------------------
;     905 // write the string str located in FLASH to the LCD
;     906 //---------------------------------------------------------------------------
;     907 void lcd_putsf(char flash *str)
;     908 {
;     909 #asm
;     910     ld   r30,y
;     911     ldd  r31,y+1
;     912 __lcd_putsf0:
;     913     lpm
;     914     tst  r0
;     915     breq __lcd_putsf1
;     916     adiw r30,1
;     917     st   -y,r0
;     918     rcall _lcd_putchar
;     919     rjmp __lcd_putsf0
;     920 __lcd_putsf1:
;     921 #endasm
;     922 }
;     923 
;     924 void _long_delay(void)
;     925 {
__long_delay:
;     926 #asm
;     927     clr   r26
    clr   r26
;     928     clr   r27
    clr   r27
;     929 __long_delay0:
__long_delay0:
;     930     sbiw  r26,1         ;2 cycles
    sbiw  r26,1         ;2 cycles
;     931     brne  __long_delay0 ;2 cycles
    brne  __long_delay0 ;2 cycles
;     932 #endasm
;     933 }
	RET
;     934 
;     935 //---------------------------------------------------------------------------
;     936 // initialize the LCD controller
;     937 //---------------------------------------------------------------------------
;     938 void lcd_init(unsigned char lcd_columns)
;     939 {
_lcd_init:
;     940 #asm
;     941 cbi   __lcd_port,__lcd_enable ;EN = 0
cbi   __lcd_port,__lcd_enable ;EN = 0
;     942 cbi   __lcd_port,__lcd_rs     ;RS = 0
cbi   __lcd_port,__lcd_rs     ;RS = 0
;     943 #endasm
;     944 
;     945 _lcd_maxx = lcd_columns;
	LDD  R9,Y+0
;     946 _base_y[2] = lcd_columns+0x80;
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
;     947 _base_y[3] = lcd_columns+0xc0;
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
;     948 
;     949 _long_delay();
	CALL SUBOPT_0x13
;     950 _lcd_write_data(0x30);
;     951 _long_delay();
	CALL SUBOPT_0x13
;     952 _lcd_write_data(0x30);
;     953 _long_delay();
	CALL SUBOPT_0x13
;     954 _lcd_write_data(0x30);
;     955 _long_delay();
	CALL __long_delay
;     956 _lcd_write_data(0x20);
	LDI  R30,LOW(32)
	CALL SUBOPT_0x12
;     957 _lcd_ready();
;     958 _lcd_write_data(0x28);
	LDI  R30,LOW(40)
	CALL SUBOPT_0x12
;     959 _lcd_ready();
;     960 _lcd_write_data(6);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
;     961 
;     962 lcd_clear();
	CALL _lcd_clear
;     963 }
	ADIW R28,1
	RET
;     964 
;     965 /////////////////////////////////////////////////////////////////////////////
;     966 // Ende von lcd.c
;     967 /////////////////////////////////////////////////////////////////////////////
;     968 /////////////////////////////////////////////////////////////////////////////
;     969 // NAME: strings.c
;     970 // FUNKTION: Enthlt Zeichenketten als Flashkonstanten
;     971 // ERSTELLT: 02/2004 - Erwin Baeck
;     972 /////////////////////////////////////////////////////////////////////////////
;     973 
;     974 #include "globals.h"
;     975 
;     976 UBYTE STRINGSLcdHeader1[] = "** TempLogger **";

	.DSEG
_STRINGSLcdHeader1:
	.BYTE 0x11
;     977 UBYTE STRINGSLcdHeader2[] = "  V1.00 by ERB  ";
_STRINGSLcdHeader2:
	.BYTE 0x11
;     978 
;     979 /////////////////////////////////////////////////////////////////////////////
;     980 // Ende von strings.c
;     981 /////////////////////////////////////////////////////////////////////////////


	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G6:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x40
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x41
_0x40:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x41:
	ADIW R28,3
	RET
__print_G6:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x42:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x44
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x48
	CPI  R19,37
	BRNE _0x49
	LDI  R16,LOW(1)
	RJMP _0x4A
_0x49:
	CALL SUBOPT_0x14
_0x4A:
	RJMP _0x47
_0x48:
	CPI  R30,LOW(0x1)
	BRNE _0x4B
	CPI  R19,37
	BRNE _0x4C
	CALL SUBOPT_0x14
	LDI  R16,LOW(0)
	RJMP _0x47
_0x4C:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x4D
	LDI  R17,LOW(1)
	RJMP _0x47
_0x4D:
	CPI  R19,43
	BRNE _0x4E
	LDI  R21,LOW(43)
	RJMP _0x47
_0x4E:
	CPI  R19,32
	BRNE _0x4F
	LDI  R21,LOW(32)
	RJMP _0x47
_0x4F:
	RJMP _0x50
_0x4B:
	CPI  R30,LOW(0x2)
	BRNE _0x51
_0x50:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x52
	ORI  R17,LOW(128)
	RJMP _0x47
_0x52:
	RJMP _0x53
_0x51:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x47
_0x53:
	CPI  R19,48
	BRLO _0x56
	CPI  R19,58
	BRLO _0x57
_0x56:
	RJMP _0x55
_0x57:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x47
_0x55:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x5B
	CALL SUBOPT_0x15
	LD   R30,X
	CALL SUBOPT_0x16
	RJMP _0x5C
_0x5B:
	CPI  R30,LOW(0x73)
	BRNE _0x5E
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
	CALL _strlen
	MOV  R16,R30
	RJMP _0x5F
_0x5E:
	CPI  R30,LOW(0x70)
	BRNE _0x61
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x5F:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x62
_0x61:
	CPI  R30,LOW(0x64)
	BREQ _0x65
	CPI  R30,LOW(0x69)
	BRNE _0x66
_0x65:
	ORI  R17,LOW(4)
	RJMP _0x67
_0x66:
	CPI  R30,LOW(0x75)
	BRNE _0x68
_0x67:
	LDI  R30,LOW(_tbl10_G6*2)
	LDI  R31,HIGH(_tbl10_G6*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x69
_0x68:
	CPI  R30,LOW(0x58)
	BRNE _0x6B
	ORI  R17,LOW(8)
	RJMP _0x6C
_0x6B:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x9A
_0x6C:
	LDI  R30,LOW(_tbl16_G6*2)
	LDI  R31,HIGH(_tbl16_G6*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x69:
	SBRS R17,2
	RJMP _0x6E
	CALL SUBOPT_0x15
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x6F
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x6F:
	CPI  R21,0
	BREQ _0x70
	SUBI R16,-LOW(1)
	RJMP _0x71
_0x70:
	ANDI R17,LOW(251)
_0x71:
	RJMP _0x72
_0x6E:
	CALL SUBOPT_0x15
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x72:
_0x62:
	SBRC R17,0
	RJMP _0x73
_0x74:
	CP   R16,R20
	BRSH _0x76
	SBRS R17,7
	RJMP _0x77
	SBRS R17,2
	RJMP _0x78
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x79
_0x78:
	LDI  R19,LOW(48)
_0x79:
	RJMP _0x7A
_0x77:
	LDI  R19,LOW(32)
_0x7A:
	CALL SUBOPT_0x14
	SUBI R20,LOW(1)
	RJMP _0x74
_0x76:
_0x73:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x7B
_0x7C:
	CPI  R18,0
	BREQ _0x7E
	SBRS R17,3
	RJMP _0x7F
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xBA
_0x7F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xBA:
	ST   -Y,R30
	CALL SUBOPT_0x18
	CPI  R20,0
	BREQ _0x81
	SUBI R20,LOW(1)
_0x81:
	SUBI R18,LOW(1)
	RJMP _0x7C
_0x7E:
	RJMP _0x82
_0x7B:
_0x84:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x86
	SBRS R17,3
	RJMP _0x87
	SUBI R19,-LOW(7)
	RJMP _0x88
_0x87:
	SUBI R19,-LOW(39)
_0x88:
_0x86:
	SBRC R17,4
	RJMP _0x8A
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x8C
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x8B
_0x8C:
	ORI  R17,LOW(16)
	RJMP _0x8E
_0x8B:
	CP   R20,R18
	BRLO _0x90
	SBRS R17,0
	RJMP _0x91
_0x90:
	RJMP _0x8F
_0x91:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x92
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x8E:
	SBRS R17,2
	RJMP _0x93
	ANDI R17,LOW(251)
	ST   -Y,R21
	CALL SUBOPT_0x18
	CPI  R20,0
	BREQ _0x94
	SUBI R20,LOW(1)
_0x94:
_0x93:
_0x92:
_0x8A:
	CALL SUBOPT_0x14
	CPI  R20,0
	BREQ _0x95
	SUBI R20,LOW(1)
_0x95:
_0x8F:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x85
	RJMP _0x84
_0x85:
_0x82:
	SBRS R17,0
	RJMP _0x96
_0x97:
	CPI  R20,0
	BREQ _0x99
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x16
	RJMP _0x97
_0x99:
_0x96:
_0x9A:
_0x5C:
	LDI  R16,LOW(0)
_0x47:
	RJMP _0x42
_0x44:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	CALL SUBOPT_0x19
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	CALL SUBOPT_0x1A
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0xB0
_printf:
	PUSH R15
	MOV  R15,R24
	CALL SUBOPT_0x19
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	CALL SUBOPT_0x1A
_0xB0:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
_ds1820_select:
	ST   -Y,R16
	CALL _w1_init
	CPI  R30,0
	BRNE _0x9B
	LDI  R30,LOW(0)
	RJMP _0xAF
_0x9B:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x9C
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
	LDI  R16,LOW(0)
_0x9E:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	CALL _w1_write
	SUBI R16,-LOW(1)
	CPI  R16,8
	BRLO _0x9E
	RJMP _0xA0
_0x9C:
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
_0xA0:
	LDI  R30,LOW(1)
_0xAF:
	LDD  R16,Y+0
	ADIW R28,3
	RET
_ds1820_read_spd:
	CALL __SAVELOCR3
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL SUBOPT_0x1B
	BRNE _0xA1
	LDI  R30,LOW(0)
	RJMP _0xAE
_0xA1:
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
	LDI  R16,LOW(0)
	__POINTWRM 17,18,___ds1820_scratch_pad
_0xA3:
	PUSH R18
	PUSH R17
	__ADDWRN 17,18,1
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R16,-LOW(1)
	CPI  R16,9
	BRLO _0xA3
	LDI  R30,LOW(___ds1820_scratch_pad)
	LDI  R31,HIGH(___ds1820_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _w1_dow_crc8
	CALL __LNEGB1
_0xAE:
	CALL __LOADLOCR3
	ADIW R28,5
	RET
_ds1820_temperature_10:
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1B
	BRNE _0xA5
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0xAD
_0xA5:
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
	LDI  R30,LOW(550)
	LDI  R31,HIGH(550)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_read_spd
	CPI  R30,0
	BRNE _0xA6
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0xAD
_0xA6:
	CALL _w1_init
	__GETB1MN ___ds1820_scratch_pad,1
	MOV  R31,R30
	LDI  R30,0
	MOVW R26,R30
	LDS  R30,___ds1820_scratch_pad
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
_0xAD:
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x30,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LD   R30,Z
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	MOV  R30,R20
	LDI  R31,0
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	__GETW2R 17,18
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETW2R 17,18
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x7:
	CALL _sprintf
	ADIW R28,12
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x8:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x9:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	MOVW R26,R28
	ADIW R26,26
	ST   X,R19
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	MOVW R26,R28
	ADIW R26,21
	ST   X,R19
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	CALL _sprintf
	ADIW R28,4
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(32)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(42)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	CALL _sprintf
	ADIW R28,4
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x12:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	CALL __long_delay
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x14:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x15:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	__PUTW2R 16,17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	JMP  __print_G6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds1820_select
	CPI  R30,0
	RET

_memset:
	ldd  r27,y+1
	ld   r26,y
	adiw r26,0
	breq __memset1
	ldd  r31,y+4
	ldd  r30,y+3
	ldd  r22,y+2
__memset0:
	st   z+,r22
	sbiw r26,1
	brne __memset0
__memset1:
	ldd  r30,y+3
	ldd  r31,y+4
	adiw r28,5
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x780
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x4B
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USW 0x130
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x618
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3B
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USW 0x140
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xB
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x45
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USW 0x12C
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1B
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
