/////////////////////////////////////////////////////////////////////////////
// NAME: lcd.h
// FUNKTION: Headerdatei fr lcd.c
//---------------------------------------------------------------------------
// Anschlsse des 2x16 LCD:
//
// RS		= PORTA.0
// R/-W		= PORTA.1
// E		= PORTA.2
// D4 - D7	= PORTA.4 - PORTA.7
/////////////////////////////////////////////////////////////////////////////
#ifndef _LCD_H_
#define _LCD_H_

#include "globals.h"

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void _lcd_ready(void);

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void _lcd_write_data(unsigned char data);

//---------------------------------------------------------------------------
// write a byte to the LCD character generator or display RAM
//---------------------------------------------------------------------------
void lcd_write_byte(unsigned char addr, unsigned char data);

//---------------------------------------------------------------------------
// read a byte from the LCD character generator or display RAM
//---------------------------------------------------------------------------
unsigned char lcd_read_byte(unsigned char addr);

//---------------------------------------------------------------------------
// set the LCD display position  x=0..39 y=0..3
//---------------------------------------------------------------------------
void lcd_gotoxy(unsigned char x, unsigned char y);

//---------------------------------------------------------------------------
// clear the LCD
//---------------------------------------------------------------------------
void lcd_clear(void);

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void lcd_putchar(char c);

//---------------------------------------------------------------------------
// write the string str located in SRAM to the LCD
//---------------------------------------------------------------------------
void lcd_puts(char *str);

//---------------------------------------------------------------------------
// write the string str located in FLASH to the LCD
//---------------------------------------------------------------------------
void lcd_putsf(char flash *str);

//---------------------------------------------------------------------------
// initialize the LCD controller
//---------------------------------------------------------------------------
void lcd_init(unsigned char lcd_columns);

#endif	//_LCD_H_

/////////////////////////////////////////////////////////////////////////////
// Ende von lcd.h
/////////////////////////////////////////////////////////////////////////////
